//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <string.h>
#include <psapi.h>
#include <ctype.h>
#include <stdlib.h>
#include <alloc.h>
#include "Unit1.h"
#include "Unit2.h"  // openprocess box
#include "Unit3.h"  // about box
#include "Unit4.h"  // form with "smart opcode" things.
#include "Unit5.h"  // form with found opcodes
#include "Unit6.h"  // form with extra modules
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define MALLOC_FAIL         "malloc() failed."
#define ONLY_NT             "This only works on Microsoft Windows 2k/NT/XP, sorry."
#define NO_PROCESS_LOADED   "No process was loaded, load a process first."
#define OPCODE_STRING_EMPTY "Opcode string is empty, choose/type ASM instructions."
#define INVALID_NR_OPCODE   "Invalid number of opcodes (not a pair number)."
#define GETPROC_FAILED      "GetProcessMemoryInfo() failed, can't get any information about process' memory usage"
#define COULDNT_ALLOC_MEM   "Couldn't allocate %d bytes of memory"
#define ERROR_IN_PROC       "An error happened in the application:\n%s\nPlease try another process."
#define ENUM_PROC_MOD_FAIL  "EnumProcessModules() failed. This process is something weird."

//#define URL                 "http://angelo.scanit.biz/tools/"

// global vars - shoot me
Tmainform *mainform;
HANDLE          handle_to_process;  // handle to process (duh)
unsigned char   *value;             // malloc'ed buffer that'll hold memory of handle_to_process
unsigned int    len = 0;                // length of value
DWORD           startAddress;
bool            all_modules = false;


//---------------------------------------------------------------------------
unsigned char r(unsigned char blah){
    // this function returns a space (h:0x20,d:32) instead of a null byte (listbox chokes on it.)
    if(blah == 0x0)
        return 32;
    else
        return blah;
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::Switch_To_RB(void){
Bevel2->Style = bsLowered;
Bevel1->Style = bsRaised;
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::Switch_To_MM(void){
Bevel1->Style = bsLowered;
Bevel2->Style = bsRaised;
}
//---------------------------------------------------------------------------
__fastcall Tmainform::Tmainform(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::fatal(AnsiString s){
    AnsiString e;
    e.printf(ERROR_IN_PROC, s.c_str());
    MessageBox(0, e.c_str(), "Error", 0);
    CleanUp();
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::OpenProcess1Click(TObject *Sender){
    DWORD                   dwError = 0,
                            memSize,
                            cbNeeded;
    PROCESS_MEMORY_COUNTERS pmc;
    unsigned int            i; // counter
    AnsiString              s = "";
    HMODULE                 hMods[1024]; // list of handles to modules

    memory->Items->Clear();
    if(frmproclist->ShowModal() == mrOk){ // load program for analysis
        handle_to_process = OpenProcess(PROCESS_VM_READ|PROCESS_QUERY_INFORMATION, FALSE, pid);
        if(handle_to_process == NULL){
            dwError = GetLastError();
            s.printf("OpenProcess() failed, error code = %d\n", dwError);
            fatal(s);
        }

        if(EnumProcessModules(handle_to_process, hMods, sizeof(hMods), &cbNeeded)){
            if (all_modules == true){ // if users wants to load all modules
                // Makes the 'controls' enabled
                Label6->Enabled = true;
                mods->Enabled = true;
                mods->Items->Clear();
                for( i = 0 ; i < cbNeeded; i++){
                    MODULEINFO ModInfo;
                    char szModName[MAX_PATH];
                    AnsiString r;
                    GetModuleInformation(handle_to_process, hMods[i],&ModInfo,sizeof(ModInfo));
                    if(GetModuleFileNameEx(handle_to_process, hMods[i], szModName, sizeof(szModName))){
                        r.printf("0x%08x, %s ", ModInfo.lpBaseOfDll, szModName);
                    } else {
                        r.printf("0x%08x, %s ", ModInfo.lpBaseOfDll, "unknown");
                    }
                    if(ModInfo.lpBaseOfDll) frmmodules->list_modules->Items->Add(r);
                    r = "";
                } // for loop
                // show the modules
                frmmodules->ShowModal();
            }// (if all_modules == true)
        }// EnumProcessModules
        else
            fatal(ENUM_PROC_MOD_FAIL);

        // get the set size of process(handle_to_process)
        if(!GetProcessMemoryInfo(handle_to_process, &pmc, sizeof(PROCESS_MEMORY_COUNTERS))){
            fatal(GETPROC_FAILED);
            return;
        }

        // get base address, should always be module[0]
        MODULEINFO ModInfo;
        GetModuleInformation(handle_to_process, hMods[0],&ModInfo,sizeof(ModInfo));
        startAddress = (unsigned long)ModInfo.lpBaseOfDll;

        // 'enables' labels for process info.
        memSize = pmc.WorkingSetSize;
        Label1->Enabled = true;
        s.printf("%d bytes", memSize);
        Label4->Enabled = true;
        Label4->Caption = s;

        memSize = (ModInfo.SizeOfImage)-1;
        len = memSize;
        if((value = (unsigned char *)malloc(memSize+1)) == NULL){
            s.printf(COULDNT_ALLOC_MEM, memSize);
            fatal(s);
            return;
        }

        if(!ReadProcessMemory(handle_to_process,(void *)startAddress,value,memSize,0)){
            fatal("ReadProcessMemory() failed : Couldn't read memory");
            return;
        }

        ProgressBar1->Max = (int)memSize;

        for(i=0;i<(memSize-16);i+=16){
            s = ""; // yak yak, don't use the same memory.. i know
            s.printf("0x%08x : %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x | %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
            startAddress+i,
            value[i+0], value[i+1], value[i+2], value[i+3],
            value[i+4], value[i+5], value[i+6], value[i+7],
            value[i+8], value[i+9], value[i+10], value[i+11],
            value[i+12], value[i+13], value[i+14], value[i+15],
            r(value[i+0]), r(value[i+1]), r(value[i+2]), r(value[i+3]),
            r(value[i+4]), r(value[i+5]), r(value[i+6]), r(value[i+7]),
            r(value[i+8]), r(value[i+9]), r(value[i+10]), r(value[i+11]),
            r(value[i+12]), r(value[i+13]), r(value[i+14]), r(value[i+15]));
            memory->Items->Add(s);
            ProgressBar1->Position += 16;
        } // for-loop
            s = "";
    } // if(showmodal = mrOk)
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::FormCreate(TObject *Sender)
{
    // exit if we're not running NT/2k/XP (2k3?)
    AnsiString s;
    OSVERSIONINFO info;
    info.dwOSVersionInfoSize = sizeof(info);
    GetVersionEx(&info);
    if(info.dwPlatformId != VER_PLATFORM_WIN32_NT){
        MessageBox(0, ONLY_NT, "Error...", mbOK),
        exit(1);
    }
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::About1Click(TObject *Sender){
    aboutfrm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::Exit1Click(TObject *Sender){
    CleanUp();
    exit(0);
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::FormClose(TObject *Sender, TCloseAction &Action){
    CleanUp();
    exit(0);
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::CleanUp(void){
    CloseHandle(handle_to_process);
    if(value){ free(value); }
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::rad_jmpMouseUp(TObject *Sender,TMouseButton Button, TShiftState Shift, int X, int Y){
    Switch_To_RB();
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::asm_codeMouseUp(TObject *Sender,TMouseButton Button, TShiftState Shift, int X, int Y){
    Switch_To_MM();
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::rad_callMouseUp(TObject *Sender,TMouseButton Button, TShiftState Shift, int X, int Y){
    Switch_To_RB();
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::rad_retMouseUp(TObject *Sender,TMouseButton Button, TShiftState Shift, int X, int Y){
    Switch_To_RB();
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::registersChange(TObject *Sender){
    Switch_To_RB();
    if(rad_call->Checked == true && rad_jmp->Checked == false){
        switch (registers->ItemIndex+1){
            case 1: // eax
                opcodes->Text = "ffd0";
                break;
            case 2: // ebx
                opcodes->Text = "ffd3";
                break;
            case 3: // ecx
                opcodes->Text = "ffd1";
                break;
            case 4: // edx
                opcodes->Text = "ffd2";
                break;
            case 5: // ebp
                opcodes->Text = "ffd5";
                break;
            case 6: // esp
                opcodes->Text = "ffd4";
                break;
            case 7: // esi
                opcodes->Text = "ffd6";
                break;
            case 8: // edi
                opcodes->Text = "ffd7";
                break;
            case 9: // [eax]
                opcodes->Text = "ff10";
                break;
            case 10: // ebx
                opcodes->Text = "ff13";
                break;
            case 11: // ecx
                opcodes->Text = "ff11";
                break;
            case 12: // edx
                opcodes->Text = "ff12";
                break;
            case 13: // ebp
                opcodes->Text = "ff5500";
                break;
            case 14: // esp
                opcodes->Text = "ff1424";
                break;
            case 15: // esi
                opcodes->Text = "ff16";
                break;
            case 16: // edi
                opcodes->Text = "ff17";
                break;
        } // switch
    } // rad_call->Enabled
    if(rad_jmp->Checked == true && rad_call->Checked == false){
        switch (registers->ItemIndex+1){
            case 1: // eax
                opcodes->Text = "ffe0";
                break;
            case 2: // ebx
                opcodes->Text = "ffe3";
                break;
            case 3: // ecx
                opcodes->Text = "ffe1";
                break;
            case 4: // edx
                opcodes->Text = "ffe2";
                break;
            case 5: // ebp
                opcodes->Text = "ffe5";
                break;
            case 6: // esp
                opcodes->Text = "ffe4";
                break;
            case 7: // esi
                opcodes->Text = "ffd6";
                break;
            case 8: // edi
                opcodes->Text = "ffd7";
                break;
            case 9: // [eax]
                opcodes->Text = "ff20";
                break;
            case 10: // ebx
                opcodes->Text = "ff23";
                break;
            case 11: // ecx
                opcodes->Text = "ff21";
                break;
            case 12: // edx
                opcodes->Text = "ff22";
                break;
            case 13: // ebp
                opcodes->Text = "ff6500";
                break;
            case 14: // esp
                opcodes->Text = "ff2424";
                break;
            case 15: // esi
                opcodes->Text = "ff26";
                break;
            case 16: // edi
                opcodes->Text = "ff27";
                break;
        } // switch
    } // rad_jmp->Enabled
    if(rad_ret->Checked == true){
        opcodes->Text = "c3";
        }
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::Button2Click(TObject *Sender){
// explains how this smart opcode thing works
    AnsiString e;
    e.printf(
    "The following instructions are allowed:\n\n"
    "\tpush <reg> \twhere <reg> is one of eax, ebx, ecx, edx, esi, edi, ebp or esp\n"
    "\tpush <val> \twhere <val> is a hexadecimal address, such as 0x4, 0xff, 0x41414141, ...\n\n"
    "\tjmp <reg>\twhere <reg> is one of the registers mentioned above\n"
    "\tjmp [<reg>]\tto access the value of the register, example: jmp [edi]\n"
    "\tjmp <32b>\twhere <32b> is any 32 bit address, example: jmp 0x12345678\n"
    "\tjmp <+n>\tjump n bytes further, example: jmp +4.  Note, use hex numbers\n\n"
    "\tcall <reg>\twhere <reg> is a register\n"
    "\tcall [<reg>]\tto call the value of the register, example: call [eax]\n"
    "\tcall <32b>\twhere <32b> is any 32 bit address, example: call 0x12345678\n"
    "\tcall <+n>\tcall n bytes further, example: call +1c.  Note, use hex numbers\n\n"
    "\tret\t\treturn opcode (same as (for example): pop ecx && jmp ecx)\n"
    "\nFor more information, go to: "__URL);
    MessageBox(0, e.c_str(), "Formation of opcodes", 0);
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::rad_retClick(TObject *Sender){
if(rad_ret->Checked == true){
    opcodes->Text = "c3";
    registers->Enabled = false;
    }
}
//---------------------------------------------------------------------------
// this function makes sure that everthing is okay with the provided opcodes
void __fastcall Tmainform::Button1Click(TObject *Sender)
{
    char *copy;
    int i;
    AnsiString s;
    opcodes->Text.LowerCase();
    if(!value){
        MessageBox(0, NO_PROCESS_LOADED,   "Error", 0);
        OpenProcess1Click(Sender);
        return;
    }
    if(opcodes->Text==""){
        MessageBox(0, OPCODE_STRING_EMPTY, "Error", 0);
        opcodes->SetFocus();
        return;
    }
    if(opcodes->Text.Length()%2){
        MessageBox(0, INVALID_NR_OPCODE,   "Error", 0);
        opcodes->SetFocus();
        return;
    }
    copy = (char *)malloc((opcodes->Text.Length())+1);
    if(!copy){ MessageBox(0, MALLOC_FAIL, "error", 0); return; }
    strncpy(copy, opcodes->Text.c_str(), opcodes->Text.Length());
    for(i=0;i<opcodes->Text.Length();i++){
        if(!isxdigit(copy[i])){
            s.printf("Error in opcodes string, '%c' is not a valid hex character.", copy[i]);
            MessageBox(0, s.c_str(), "Error", 0);
            free(copy);
            return;
        }
    }
    free(copy);
    FindInMemory(opcodes->Text);
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::FindInMemory(AnsiString s){
    // translates "c3" to 0xc3 and finds it in memory.

    // make NOP's in between enabled?
    // for instance:
    //  add esp, 0x100
    //  jmp esp
    // can also be the same as
    //  add esp, 0x100
    //  inc ecx
    //  nop
    //  xchg ebx,ecx
    //  jmp esp

    unsigned int vSize,
                 oSize,
                 i,
                 j,
                 counter = 0;
    bool         flag;
    int          opcode_values[64+1],
                 opcode;
    char         temp[3],
                 *AnsiCopy;
    AnsiString   a;

    // "41" (2bytes) becomes 0x41 (1 byte)
    oSize = (s.Length() / 2);
    // allocate memory and check
    AnsiCopy      = (char *)malloc(s.Length()+1);
    if(!AnsiCopy){      MessageBox(0, MALLOC_FAIL, "error", 0); return; }
    // set all vars to zero
    memset(opcode_values,   0x0, 64+1);
    memset(AnsiCopy,        0x0, s.Length()+1);
    strncpy(AnsiCopy, s.c_str(), s.Length()); // to avoid using the same c_str() function everytime

    // maybe not the best solution, but this for loop does:
    // "c3b4" -> "c3\0" -> 0xc3, "b4\0" -> 0xb4
    for(i=0;(i<oSize)&&(i<64);i++){
        temp[0] = AnsiCopy[i*2];
        temp[1] = AnsiCopy[(i*2)+1];
        temp[2] = 0x0;
        sscanf(temp, "%x", &opcode);
        opcode_values[i] = opcode;
    }

    vSize = len;

    frmfound->ListBox1->Items->Clear();

    for(i=0;i<vSize;i++){ // finds the opcodes in memory
        flag = false;
        if(value[i] == opcode_values[0]){
            flag = true;
            if(oSize > 1)
                for(j=1;j<oSize && (flag == true);j++)   // we can start from opcode_values[1]
                    if(value[i+j] != opcode_values[j]) flag = false;
            if(flag == true){
                counter++;
                a.printf("%2d : opcode found at (0x%08x)", counter, startAddress+i);
                frmfound->ListBox1->Items->Add(a);
            }
        }
    }
    a.printf("Found %d instances", counter);
    frmfound->Label1->Caption = a;
    frmfound->ShowModal();
    free(AnsiCopy);
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::rad_callClick(TObject *Sender){
registers->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall Tmainform::rad_jmpClick(TObject *Sender){
registers->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall Tmainform::Button3Click(TObject *Sender){
    // checks the syntax of asm_code and forms opcodes
    AnsiString  s,      // playground
                res;    // result (opcodes)
    char instruction[8] = {0 } ; // okay overkill
    char arg1[12] = { 0 };    // "
    char arg2[12] = { 0 };    // "
    char temp[101], *ptemp;
    unsigned int i=0,j = 0;
    int LineCounter = 0;
    bool arg1flag = 0;

    struct _arginst { char inst[6]; unsigned int num_arg; }
        arginst[] = {
        { "push"  , 1 },
        { "pushl" , 1 },
        { "pop"   , 1 },
        { "popl"  , 1 },
        { "mov"   , 2 },
        { "movb"  , 2 },
        { "movw"  , 2 },
        { "movl"  , 2 },
        { "jmp"   , 1 },
        { "jl"    , 1 },
        { "jg"    , 1 },
        { "je"    , 1 },
        { "jle"   , 1 },
        { "jge"   , 1 },
        { "ret"   , 0 },
        { NULL    , 0 }
        };

    memset(temp, 0x0, 101);
    strncpy(temp,asm_code->Text.c_str(), 100);
    ptemp = temp;

    while(sscanf(ptemp, "%6s", instruction) > 0){
        if (strlen(instruction) == 0) return;
        i = 0;
        while(i < 16 && strncmp(arginst[i].inst, instruction, 5)) i++;
        if(i==16){
            s.printf("Wrong syntax, \"%s\" was not recognized as a valid, supported x86 instruction.\n", instruction);
            MessageBox(0, s.c_str(), "Error", 0);
            return;
            }
        ptemp += strlen(arginst[i].inst)+1;
        memset(arg1, 0x0, 12); memset(arg2, 0x0, 12);
        while(*ptemp == ' ') ptemp++;

        if ((arginst[i].num_arg)== 1 ){ sscanf(ptemp, "%10s", arg1); ptemp += (strlen(arg1)); }
        if ((arginst[i].num_arg)== 2 ){
            while(*ptemp == 0x20) ptemp++;
            for(j=0;(j<12&&*ptemp!=',');j++){ arg1[j] = *ptemp; ptemp++; }
            while(*ptemp==0x20||*ptemp==',') ptemp++;
            for(j=0;(j<12&&*ptemp!=' '&&*ptemp!='\r'&&*ptemp!='\n');j++){
                arg2[j] = *ptemp; ptemp++;
            }
        }

        if(*ptemp == '\r' || *ptemp == '\n') ptemp++;

    // ----- we got it all, now put it into the opcodes->Text field --- //

        if(!strncmp("ret", instruction, 3)) res = res + "c3";
        if(!strncmp("push", instruction, 4)){
            if(!strncmp("eax", arg1, 3)) res = res + "50";
            if(!strncmp("ebx", arg1, 3)) res = res + "53";
            if(!strncmp("ecx", arg1, 3)) res = res + "51";
            if(!strncmp("edx", arg1, 3)) res = res + "52";
            if(!strncmp("esp", arg1, 3)) res = res + "54";
            if(!strncmp("edi", arg1, 3)) res = res + "57";
            if(!strncmp("esi", arg1, 3)) res = res + "56";
            if(!strncmp("ebp", arg1, 3)) res = res + "55";
            // numeric (hex) value
            if(!strncmp("0x", arg1, 2)){
                switch(strlen(arg1)){
                    case 3: res = res + "6a0" + arg1[2]; break;
                    case 4: res = res + "6a"  + arg1[2] + arg1[3]; break;
                    case 5: res = res + "68"  + arg1[3] + arg1[4] + "0" + arg1[2] + "0000" ; break;
                    case 6: res = res + "68"  + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "0000"; break;
                    case 7: res = res + "68"  + arg1[5] + arg1[6] + arg1[3] + arg1[4] + "0" + arg1[2] + "00"; break;
                    case 8: res = res + "68"  + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "00"; break;
                    case 9: res = res + "68"  + arg1[7] + arg1[8] + arg1[5] + arg1[6] + arg1[3] + arg1[4] + "0" + arg1[2]; break;
                    case 10: res = res + "68"  + arg1[8] + arg1[9] + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3]; break;
                    default: MessageBox(0, "Invalid push operand", "error", 0); break;
                } // switch
            } // strncmp("0x", arg1,2)
        } // push

        if(!strncmp("jmp", instruction, 3)){

            if(!strncmp("eax", arg1, 3)) res = res + "ffe0";
            if(!strncmp("ebx", arg1, 3)) res = res + "ffe3";
            if(!strncmp("ecx", arg1, 3)) res = res + "ffe1";
            if(!strncmp("edx", arg1, 3)) res = res + "ffe2";
            if(!strncmp("esp", arg1, 3)) res = res + "ffe4";
            if(!strncmp("edi", arg1, 3)) res = res + "ffe7";
            if(!strncmp("esi", arg1, 3)) res = res + "ffe6";
            if(!strncmp("ebp", arg1, 3)) res = res + "ffe5";

            if(!strncmp("[eax]", arg1, 3)) res = res + "ff20";
            if(!strncmp("[ebx]", arg1, 3)) res = res + "ff23";
            if(!strncmp("[ecx]", arg1, 3)) res = res + "ff21";
            if(!strncmp("[edx]", arg1, 3)) res = res + "ff22";
            if(!strncmp("[esp]", arg1, 3)) res = res + "ff2424";
            if(!strncmp("[edi]", arg1, 3)) res = res + "ff27";
            if(!strncmp("[esi]", arg1, 3)) res = res + "ff26";
            if(!strncmp("[ebp]", arg1, 3)) res = res + "ff6500";

            if(!strncmp("+", arg1, 1)){
                switch(strlen(arg1)){
                    case 2: res = res + "eb" + "0" + arg1[1]; break;
                    case 3: res = res + "eb" + arg1[1] + arg1[2]; break;
                    case 4: res = res + "e9"  + arg1[2] + arg1[3] + "0" + arg1[1] + "0000" ; break;
                    case 5: res = res + "e9"  + arg1[3] + arg1[4] + arg1[1] + arg1[2] + "0000"; break;
                    case 6: res = res + "e9"  + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "0" + arg1[2] + "00"; break;
                    case 7: res = res + "e9"  + arg1[5] + arg1[6] + arg1[3] + arg1[4] + arg1[1] + arg1[2] + "00"; break;
                    case 8: res = res + "e9"  + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "0" + arg1[1]; break;
                    case 9: res = res + "e9"  + arg1[7] + arg1[8] + arg1[5] + arg1[6] + arg1[3] + arg1[4] + arg1[2] + arg1[3]; break;
                    default: MessageBox(0, "Invalid jmp +operand", "error", 0); break;
                } // switch
            } // if

            // numeric (hex) value
            if(!strncmp("0x", arg1, 2)){
                switch(strlen(arg1)){
                    case 10: res = res + "ff25"  + arg1[8] + arg1[9] + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3]; break;
                    default:
                        MessageBox(0, "jmp can only be used with 32bit addresses, such as 0x12345678,\nuse +<val> for relative values.  Such as jmp +4", "Error", 0);
                        break;
                } // switch
            } // strncmp("0x", arg1,2)
        } // jmp

        if(!strncmp("call", instruction, 4)){
            if(!strncmp("eax", arg1, 3)) res = res + "ffd0";
            if(!strncmp("ebx", arg1, 3)) res = res + "ffd3";
            if(!strncmp("ecx", arg1, 3)) res = res + "ffd1";
            if(!strncmp("edx", arg1, 3)) res = res + "ffd2";
            if(!strncmp("esp", arg1, 3)) res = res + "ffd4";
            if(!strncmp("edi", arg1, 3)) res = res + "ffd7";
            if(!strncmp("esi", arg1, 3)) res = res + "ffd6";
            if(!strncmp("ebp", arg1, 3)) res = res + "ffd5";
            if(!strncmp("[eax]", arg1, 3)) res = res + "ff10";
            if(!strncmp("[ebx]", arg1, 3)) res = res + "ff13";
            if(!strncmp("[ecx]", arg1, 3)) res = res + "ff11";
            if(!strncmp("[edx]", arg1, 3)) res = res + "ff12";
            if(!strncmp("[esp]", arg1, 3)) res = res + "ff1424";
            if(!strncmp("[edi]", arg1, 3)) res = res + "ff17";
            if(!strncmp("[esi]", arg1, 3)) res = res + "ff16";
            if(!strncmp("[ebp]", arg1, 3)) res = res + "ff5500";

            if(!strncmp("+", arg1, 1)){
                switch(strlen(arg1)){
                    case 2: res = res + "e8" + "0" + arg1[1] + "000000" ; break;
                    case 3: res = res + "e8" + arg1[1] + arg1[2] + "000000" ; break;
                    case 5: res = res + "e8"  + arg1[2] + arg1[3] + "0" + arg1[1] + "0000" ; break;
                    case 6: res = res + "e8"  + arg1[3] + arg1[4] + arg1[1] + arg1[2] + "0000"; break;
                    case 7: res = res + "e8"  + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "0" + arg1[2] + "00"; break;
                    case 8: res = res + "e8"  + arg1[5] + arg1[6] + arg1[3] + arg1[4] + arg1[1] + arg1[2] + "00"; break;
                    case 9: res = res + "e8"  + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3] + "0" + arg1[1]; break;
                    case 10: res= res + "e8"  + arg1[7] + arg1[8] + arg1[5] + arg1[6] + arg1[3] + arg1[4] + arg1[2] + arg1[3]; break;
                    default: MessageBox(0, "Invalid jmp +operand", "error", 0); break;
                } // switch
            } // if

            // numeric (hex) value
            if(!strncmp("0x", arg1, 2)){
                switch(strlen(arg1)){
                    case 10: res = res + "ff15"  + arg1[8] + arg1[9] + arg1[6] + arg1[7] + arg1[4] + arg1[5] + arg1[2] + arg1[3]; break;
                    default:
                        MessageBox(0, "call can only be used with 32bit addresses, such as 0x12345678,\nuse +<val> for relative values.  Such as call +4", "Error", 0);
                        break;
                } // switch
            } // strncmp("0x", arg1,2)
        } // call

    }   // while (sscanf)

    ptemp = NULL;
    ptemp = (char *)malloc(sizeof(char) * res.Length()+1);
    if(!ptemp){ MessageBox(0, MALLOC_FAIL, "Error", 0); CleanUp();}
    memset(ptemp, 0x0,res.Length()+1);
    strncpy(ptemp, res.c_str(), res.Length());

    for(i=0;i<res.Length();i++){
        if(!isxdigit(*(ptemp+i))){
            s.printf("Error in opcode string, %c is not a hexadecimal character", ptemp[i]);
            MessageBox(0, s.c_str(), "", 0);
            res = "";
            asm_code->SetFocus();
        }
    }

    free(ptemp);
    opcodes->Text = res;
}
//---------------------------------------------------------------------------


